searchNodes=[{"doc":"A package containing generators to generate an admin backend for your Phoenix app. The package relies a lot on generators, and Mandarin itself provides a minimal API at runtime. This is be design, as the code produced with generators is easier to customize than overridable API calls, or other alternatives that depend a lot on macros. The basic idea is tha Mandarin generates normal Phoenix contexts, views, templates and controllers, much like the ones you'd write yourself. The generated files follow roughly the same conventinos as the ones you'd write yourself. Mandarin relies heavily on the forage package for filtering, sorting and paginating the results in the CRUD views.","ref":"Mandarin.html","title":"Mandarin","type":"module"},{"doc":"Convenience functions to design an application (paramsbase, schemas, contexts and HTML) in a programmatic way. This is equivalent to using the Phoenix and Mandarin generators, but with a nicer API which allows you to use the full power of the Elixir language to run the generators instead of relying on custom bash scripts or manually running the generators.","ref":"Mandarin.Designer.html","title":"Mandarin.Designer","type":"module"},{"doc":"","ref":"Mandarin.Designer.html#drop_migrations_if_already_exist/2","title":"Mandarin.Designer.drop_migrations_if_already_exist/2","type":"function"},{"doc":"Generate a mandarin context (without generating a web interface)","ref":"Mandarin.Designer.html#generate_mandarin_context/2","title":"Mandarin.Designer.generate_mandarin_context/2","type":"function"},{"doc":"Generate a mandarin context (without generating a web interface). If the params belong to a join_through table, this is the same as running generate_mandarin_schema(params) .","ref":"Mandarin.Designer.html#generate_mandarin_html/2","title":"Mandarin.Designer.generate_mandarin_html/2","type":"function"},{"doc":"Generate mandarin web interfaces (schemas, context and the web part) for a list of params. If the any params belong to a join_through table, this will run generate_mandarin_schema(params) for those params.","ref":"Mandarin.Designer.html#generate_mandarin_html_for_all/3","title":"Mandarin.Designer.generate_mandarin_html_for_all/3","type":"function"},{"doc":"Generate a mandarin schema (without generating a context or any web interface). This might be useful for schemas that are meant to act only as join_through tables for many-to-many relations. These schemas don't require a context or a web interface. In fact, the user is not meant to interact with them directly. Ecto will be capable of using them when required if the schemas are configured correctly.","ref":"Mandarin.Designer.html#generate_mandarin_schema/2","title":"Mandarin.Designer.generate_mandarin_schema/2","type":"function"},{"doc":"Install Mandarin into the given context . The context should be an upper case plural string (this function doesn't take a ) Example install_mandarin ( &quot;Admin&quot; )","ref":"Mandarin.Designer.html#install_mandarin/1","title":"Mandarin.Designer.install_mandarin/1","type":"function"},{"doc":"Create a foreign key reference","ref":"Mandarin.Designer.html#references/1","title":"Mandarin.Designer.references/1","type":"function"},{"doc":"Tag a field as unique.","ref":"Mandarin.Designer.html#unique/1","title":"Mandarin.Designer.unique/1","type":"function"},{"doc":"Update the options for a list","ref":"Mandarin.Designer.html#update_options/2","title":"Mandarin.Designer.update_options/2","type":"function"},{"doc":"Run a function ( fun ) which may create migration files and add marker files to migrations path to delimit which migrations were generated. This makes it easier to see which migrations were generated as a group. The migration files will contain the tag in the file name, so you may want to make it descriptive.","ref":"Mandarin.Designer.html#with_ecto_design_markers/3","title":"Mandarin.Designer.with_ecto_design_markers/3","type":"function"},{"doc":"A trivial plug to add the type of resource to the conn . Currently this is used by the generators to decide which link in the sidebar has focus.","ref":"Mandarin.Plugs.Resource.html","title":"Mandarin.Plugs.Resource","type":"module"},{"doc":"Macros to simplify the definition of routes.","ref":"Mandarin.Router.html","title":"Mandarin.Router","type":"module"},{"doc":"Add routes for a full-fledged Mandarin controller. The same as Phoenix.Router.resources/3 , but with an extra &lt;resource&gt;/select route, for use with Forage 's select widget.","ref":"Mandarin.Router.html#resources/3","title":"Mandarin.Router.resources/3","type":"macro"},{"doc":"Prints Mandarin tasks and their information. mix mandarin","ref":"Mix.Tasks.Mandarin.html","title":"Mix.Tasks.Mandarin","type":"task"},{"doc":"Generates a context with functions around an Ecto schema. mix mandarin . gen . context Admin User users name :string age :integer The first argument is the context module followed by the schema module and its plural name (used as the schema table name). The context is an Elixir module that serves as an API boundary for the given resource. A context often holds many related resources. Therefore, if the context already exists, it will be augmented with functions for the given resource. Note: A resource may also be split over distinct contexts (such as Accounts.User and Payments.User). The schema is responsible for mapping the database fields into an Elixir struct. Overall, this generator will add the following files to lib/your_app : a context module in accounts/admin.ex , serving as the API boundary a schema in admin/user.ex , with a users table A migration file for the repository and test files for the context will also be generated. Generating without a schema In some cases, you may wish to bootstrap the context module and tests, but leave internal implementation of the context and schema to yourself. Use the --no-schema flags to accomplish this. table By default, the table name for the migration and schema will be the plural name provided for the resource. To customize this value, a --table option may be provided. For example: mix mandarin . gen . context Admin User users -- table cms_users binary_id Generated migration can use binary_id for schema's primary key and its references with option --binary-id . Default options This generator uses default options provided in the :generators configuration of your application. These are the defaults: config :your_app , :generators , migration : true , binary_id : false , sample_binary_id : &quot;11111111-1111-1111-1111-111111111111&quot; You can override those options per invocation by providing corresponding switches, e.g. --no-binary-id to use normal ids despite the default configuration or --migration to force generation of the migration. Read the documentation for mandarin.gen.schema for more information on attributes.","ref":"Mix.Tasks.Mandarin.Gen.Context.html","title":"Mix.Tasks.Mandarin.Gen.Context","type":"task"},{"doc":"","ref":"Mix.Tasks.Mandarin.Gen.Context.html#prompt_for_code_injection/1","title":"Mix.Tasks.Mandarin.Gen.Context.prompt_for_code_injection/1","type":"function"},{"doc":"Generates controller, views, and context for an HTML resource. mix mandarin . gen . html Admin User users name :string age :integer The first argument is the context module followed by the schema module and its plural name (used as the schema table name). The context is an Elixir module that serves as an API boundary for the given resource. A context often holds many related resources. Therefore, if the context already exists, it will be augmented with functions for the given resource. Note: A resource may also be split over distinct contexts (such as admin.User and Payments.User ). The schema is responsible for mapping the database fields into an Elixir struct. Overall, this generator will add the following files to lib/ : a context module in lib/app/admin/admin.ex for the admin API a schema in lib/app/admin/user.ex , with an users table a view in lib/app_web/views/user_view.ex a controller in lib/app_web/controllers/user_controller.ex default CRUD templates in lib/app_web/templates/user A migration file for the repository and test files for the context and controller features will also be generated. The location of the web files (controllers, views, templates, etc) in an umbrella application will vary based on the :context_app config located in your applications :generators configuration. When set, the Mandarin generators will generate web files directly in your lib and test folders since the application is assumed to be isolated to web specific functionality. If :context_app is not set, the generators will place web related lib and test files in a web/ directory since the application is assumed to be handling both web and domain specific functionality. Example configuration: config :my_app_web , :generators , context_app : :my_app Alternatively, the --context-app option may be supplied to the generator: mix mandarin . gen . html Sales User users -- context - app warehouse Web namespace By default, the controller and view will be namespaced by the schema name. You can customize the web module namespace by passing the --web flag with a module name, for example: mix mandarin . gen . html Sales User users -- web Sales Which would generate a lib/app_web/controllers/sales/user_controller.ex and lib/app_web/views/sales/user_view.ex . Generating without a schema or context file In some cases, you may wish to bootstrap HTML templates, controllers, and controller tests, but leave internal implementation of the context or schema to yourself. You can use the --no-context and --no-schema flags for file generation control. table By default, the table name for the migration and schema will be the plural name provided for the resource. To customize this value, a --table option may be provided. For example: mix mandarin . gen . html admin User users -- table cms_users binary_id Generated migration can use binary_id for schema's primary key and its references with option --binary-id . Default options This generator uses default options provided in the :generators configuration of your application. These are the defaults: config :your_app , :generators , migration : true , binary_id : false , sample_binary_id : &quot;11111111-1111-1111-1111-111111111111&quot; You can override those options per invocation by providing corresponding switches, e.g. --no-binary-id to use normal ids despite the default configuration or --migration to force generation of the migration. Read the documentation for mandarin.gen.schema for more information on attributes.","ref":"Mix.Tasks.Mandarin.Gen.Html.html","title":"Mix.Tasks.Mandarin.Gen.Html","type":"task"},{"doc":"","ref":"Mix.Tasks.Mandarin.Gen.Html.html#inputs/1","title":"Mix.Tasks.Mandarin.Gen.Html.inputs/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Mandarin.Gen.Html.html#routes_for_context/1","title":"Mix.Tasks.Mandarin.Gen.Html.routes_for_context/1","type":"function"},{"doc":"Generates an Ecto schema and migration. mix mandarin . gen . schema Blog.Post blog_posts title :string views :integer The first argument is the schema module followed by its plural name (used as the table name). The generated schema above will contain: a schema file in lib/my_app/blog/post.ex , with a blog_posts table a migration file for the repository The generated migration can be skipped with --no-migration . Contexts Your schemas can be generated and added to a separate OTP app. Make sure your configuration is properly setup or manually specify the context app with the --context-app option with the CLI. # Via config config :marketing_web , :generators , context_app : :marketing # Via CLI mix mandarin . gen . schema Blog.Post blog_posts title :string views :integer -- context - app marketing Attributes The resource fields are given using name:type syntax where type are the types supported by Ecto. Omitting the type makes it default to :string : mix mandarin . gen . schema Blog.Post blog_posts title views :integer The following types are supported: :integer :float :decimal :boolean :map :string :array :references :text :date :time :naive_datetime :utc_datetime :uuid :binary :datetime - An alias for :naive_datetime The generator also supports references, which we will properly associate the given column to the primary key column of the referenced table: mix mandarin . gen . schema Blog.Post blog_posts title user_id :references :users This will result in a migration with an :integer column of :user_id and create an index. TODO: Support many-to-many relations. Furthermore an array type can also be given if it is supported by your database, although it requires the type of the underlying array element to be given too: mix mandarin . gen . schema Blog.Post blog_posts tags :array :string Unique columns can be automatically generated by using: mix mandarin . gen . schema Blog.Post blog_posts title :unique unique_int :integer :unique If no data type is given, it defaults to a string. table By default, the table name for the migration and schema will be the plural name provided for the resource. To customize this value, a --table option may be provided. For example: mix mandarin . gen . schema Blog.Post posts -- table cms_posts binary_id Generated migration can use binary_id for schema's primary key and its references with option --binary-id . Default options This generator uses default options provided in the :generators configuration of your application. These are the defaults: config :your_app , :generators , migration : true , binary_id : false , sample_binary_id : &quot;11111111-1111-1111-1111-111111111111&quot; You can override those options per invocation by providing corresponding switches, e.g. --no-binary-id to use normal ids despite the default configuration or --migration to force generation of the migration.","ref":"Mix.Tasks.Mandarin.Gen.Schema.html","title":"Mix.Tasks.Mandarin.Gen.Schema","type":"task"},{"doc":"Installs the files into your application","ref":"Mix.Tasks.Mandarin.Install.html","title":"Mix.Tasks.Mandarin.Install","type":"task"},{"doc":"","ref":"Mix.Tasks.Mandarin.Install.html#build/3","title":"Mix.Tasks.Mandarin.Install.build/3","type":"function"},{"doc":"","ref":"Mix.Tasks.Mandarin.Install.html#files_to_be_generated/1","title":"Mix.Tasks.Mandarin.Install.files_to_be_generated/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Mandarin.Install.html#sidebar_path/2","title":"Mix.Tasks.Mandarin.Install.sidebar_path/2","type":"function"},{"doc":"","ref":"Mix.Tasks.Mandarin.Install.html#write_p!/2","title":"Mix.Tasks.Mandarin.Install.write_p!/2","type":"function"}]